!!****m* ABINIT/interfaces_64_atompaw
!! NAME
!! interfaces_64_atompaw
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/64_atompaw
!!
!! COPYRIGHT
!! Copyright (C) 2010-2013 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: config/scripts/abilint . .
!!
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module interfaces_64_atompaw

 implicit none

interface
 subroutine fit_gen(mparam,nparam_out,nterm_bounds,nr,&  
  &  param_out,pawrad,option,outfile,rpaw,y,comm_mpi)
  use defs_basis
  use m_pawrad
  implicit none
  integer,intent(in),optional :: comm_mpi
  integer,intent(in) :: mparam
  integer,intent(out) :: nparam_out
  integer,intent(in) :: nr
  integer,intent(in) :: option
  character(80),intent(in) :: outfile
  type(pawrad_type),intent(in) :: pawrad
  real(dp),intent(in) :: rpaw
  integer,intent(in) :: nterm_bounds(2)
  real(dp),intent(out) :: param_out(mparam)
  real(dp),intent(inout) :: y(nr)
 end subroutine fit_gen
end interface

interface
 subroutine fit(chisq,constrains,&  
  &  limit,maxiter,nparam,nterm,nx,option,outfile,param,&  
  &  verbosity,weight,x,y,y_out)
  use defs_basis
  implicit none
  integer, intent(in) :: maxiter
  integer, intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  integer,intent(in) :: option
  integer,intent(in) :: verbosity
  real(dp),intent(out) :: chisq
  character(80),intent(in) :: outfile
  integer,intent(in) :: constrains(nparam)
  real(dp),intent(in) :: limit(nparam)
  real(dp),intent(inout) :: param(nparam)
  real(dp),intent(in) :: weight(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(in) :: y(nx)
  real(dp),intent(out) :: y_out(nx)
 end subroutine fit
end interface

interface
 subroutine calcgaussr(nterm,nparam,nx,opt,&  
  &  param,x,y_out,deriv)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  integer,intent(in) :: opt
  real(dp),optional,intent(out) :: deriv(nx,nparam)
  real(dp),intent(in) :: param(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(out) :: y_out(nx)
 end subroutine calcgaussr
end interface

interface
 subroutine calcgaussc3(nparam,nterm,nx,opt,&  
  &  param,x,y_out,deriv)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  integer,intent(in) :: opt
  real(dp),optional,intent(out) :: deriv(nx,nparam)
  real(dp),intent(in) :: param(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(out) :: y_out(nx)
 end subroutine calcgaussc3
end interface

interface
 subroutine calcgaussc2(nparam,nterm,nx,opt,&  
  &  param,x,y_out,deriv)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  integer,intent(in) :: opt
  real(dp),optional,intent(out) :: deriv(nx,nparam)
  real(dp),intent(in) :: param(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(out) :: y_out(nx)
 end subroutine calcgaussc2
end interface

interface
 subroutine calcgaussc(nparam,nterm,nx,opt,&  
  &  param,x,y_out,deriv)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  integer,intent(in) :: opt
  real(dp),optional,intent(out) :: deriv(nx,nparam)
  real(dp),intent(in) :: param(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(out) :: y_out(nx)
 end subroutine calcgaussc
end interface

interface
 subroutine calcgaussc4(nparam,nterm,nx,opt,&  
  &  param,x,y_out,deriv)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  integer,intent(in) :: opt
  real(dp),optional,intent(out) :: deriv(nx,nparam)
  real(dp),intent(in) :: param(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(out) :: y_out(nx)
 end subroutine calcgaussc4
end interface

interface
 subroutine RestreinedLeastSquaresFit(&  
  &  chisq,constrains,limit,maxiter,&  
  &  nterm,nparam,nx,option,parameters,&  
  &  verbosity,weight,x,y)
  use defs_basis
  implicit none
  integer, intent(in) :: maxiter
  integer, intent(in) :: nparam
  integer, intent(in) :: nterm
  integer, intent(in) :: nx
  integer, intent(in) :: option
  integer, intent(in) :: verbosity
  real(dp),intent(out) :: chisq
  integer, intent(in) :: constrains(nparam)
  real(dp),intent(in) :: limit(nparam)
  real(dp),intent(inout) :: parameters(nparam)
  real(dp),intent(in) :: weight(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(in) :: y(nx)
 end subroutine RestreinedLeastSquaresFit
end interface

interface
 subroutine ChisqAlphaBeta(alpha,beta,chisq,&  
  &  nparam,nterm,nx,option,parameters,x,y)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  integer,intent(in) :: option
  real(dp),intent(out) :: chisq
  real(dp),intent(out) :: alpha(nparam,nparam)
  real(dp),intent(out) :: beta(nparam)
  real(dp),intent(in) :: parameters(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(in) :: y(nx)
 end subroutine ChisqAlphaBeta
end interface

interface
 subroutine setparam1(nterm,nparam,nx,param,sep,x,y)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  real(dp),intent(in) :: sep
  real(dp),intent(out) :: param(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(in) :: y(nx)
 end subroutine setparam1
end interface

interface
 subroutine setparam2(nterm,nparam,nx,param,rpaw,x,y)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  real(dp),intent(in) :: rpaw
  real(dp),intent(out) :: param(nparam)
  real(dp),intent(in) :: x(nx)
  real(dp),intent(in) :: y(nx)
 end subroutine setparam2
end interface

interface
 subroutine setparam3(nterm,nparam,param,sep)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  real(dp),intent(in) :: sep
  real(dp),intent(out) :: param(nparam)
 end subroutine setparam3
end interface

interface
 subroutine setparam4(nparam,param)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  real(dp),intent(out) :: param(nparam)
 end subroutine setparam4
end interface

interface
 subroutine setparam5(nterm,nparam,nx,param,rpaw,y)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  real(dp),intent(in) :: rpaw
  real(dp),intent(out) :: param(nparam)
  real(dp),intent(in) :: y(nx)
 end subroutine setparam5
end interface

interface
 subroutine constrains_ini(cons1,cons2,limit,nparam,nterm,nx,option,rpaw,y)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: nterm
  integer,intent(in) :: nx
  integer,intent(in) :: option
  real(dp),intent(in) :: rpaw
  real(dp),intent(out) :: cons1(nparam)
  integer,intent(out) :: cons2(nparam)
  real(dp),intent(out) :: limit(nparam)
  real(dp),intent(in) :: y(nx)
 end subroutine constrains_ini
end interface

interface
 subroutine get_parameters(const,limit,nparam,param_in,param_out)
  use defs_basis
  implicit none
  integer,intent(in) :: nparam
  integer,intent(in) :: const(nparam)
  real(dp),intent(in) :: limit(nparam)
  real(dp),intent(in) :: param_in(nparam)
  real(dp),intent(out) :: param_out(nparam)
 end subroutine get_parameters
end interface

interface
 subroutine pawdij0(indlmn,kij,lmnmax,ncore,opt_init,pawtab,radmesh,radmesh_core,radmesh_vloc,vhtnzc,znucl)
  use defs_basis
  use m_pawrad
  use m_pawtab
  implicit none
  integer,intent(in) :: lmnmax
  integer,intent(in) :: opt_init
  type(pawtab_type),intent(inout) :: pawtab
  type(pawrad_type),intent(in) :: radmesh
  type(pawrad_type),intent(in) :: radmesh_core
  type(pawrad_type),intent(in) :: radmesh_vloc
  real(dp),intent(in) :: znucl
  integer,intent(in) :: indlmn(6,lmnmax)
  real(dp),intent(in) :: kij(pawtab%lmn2_size)
  real(dp),intent(in) :: ncore(radmesh_core%mesh_size)
  real(dp),intent(in) :: vhtnzc(radmesh_vloc%mesh_size)
 end subroutine pawdij0
end interface

interface
 subroutine pawkij(indlmn,kij,lmnmax,ncore,opt_init,opt_vhnzc,pawtab,radmesh,radmesh_core,radmesh_vloc,vhtnzc,znucl)
  use defs_basis
  use m_pawrad
  use m_pawtab
  implicit none
  integer,intent(in) :: lmnmax
  integer,intent(in) :: opt_init
  integer,intent(in) :: opt_vhnzc
  type(pawtab_type),intent(in) :: pawtab
  type(pawrad_type),intent(in) :: radmesh
  type(pawrad_type),intent(in) :: radmesh_core
  type(pawrad_type),intent(in) :: radmesh_vloc
  real(dp),intent(in) :: znucl
  integer,intent(in) :: indlmn(6,lmnmax)
  real(dp),intent(out) :: kij(pawtab%lmn2_size)
  real(dp),intent(in) :: ncore(radmesh_core%mesh_size)
  real(dp),intent(in) :: vhtnzc(radmesh_vloc%mesh_size)
 end subroutine pawkij
end interface

interface
 subroutine pawshpfun(ll,mesh,norm,pawtab,shapefunc)
  use defs_basis
  use m_pawrad
  use m_pawtab
  implicit none
  integer,intent(in) :: ll
  type(pawrad_type),intent(in) :: mesh
  real(dp),intent(out) :: norm
  type(pawtab_type),intent(in) :: pawtab
  real(dp),intent(inout) :: shapefunc(mesh%mesh_size)
 end subroutine pawshpfun
end interface

interface
 subroutine pawvhnzc(ncore,radmesh_core,vhnzc,znucl)
  use defs_basis
  use m_pawrad
  implicit none
  type(pawrad_type),intent(in) :: radmesh_core
  real(dp),intent(in) :: znucl
  real(dp),intent(in) :: ncore(radmesh_core%mesh_size)
  real(dp), intent(out) :: vhnzc(radmesh_core%mesh_size)
 end subroutine pawvhnzc
end interface

interface
 subroutine shapebes(al,ql,ll,rc)
  use defs_basis
  implicit none
  integer :: ll
  real(dp) :: rc
  real(dp) :: al(2)
  real(dp) :: ql(2)
 end subroutine shapebes
end interface

interface
 subroutine vhar2rho(pawrad,rho,v)
  use defs_basis
  use m_pawrad
  implicit none
  type(pawrad_type),intent(in) :: pawrad
  real(dp), intent(out) :: rho(pawrad%mesh_size)
  real(dp), intent(in) :: v(pawrad%mesh_size)
 end subroutine vhar2rho
end interface

end module interfaces_64_atompaw
!!***
